<template>
    <div class="calc">
        <div class="calc_wrapper">

            <!-- сумма займа -->
            <div class="part">
                <div class="block__wrapper">
                    <div class="block">
                        <div class="label">Сумма</div>
                        <div class="label-value">{{value.sum|currency}} ₽</div>
                    </div>
                    <div class="line"></div>
                    <div class="block">
                        <div class="label">Сумма возврата <template v-if="servicePrice">(с учетом доп. услуг)</template></div>
                        <div class="label-value small">{{returnAmount|currency}} ₽</div>
                    </div>
                </div>

                <div class="slider">
                    <range-slider class="slider"
                                  :min="$calculate.sum_min"
                                  :max="$calculate.sum_max"
                                  :step="500"
                                  v-model="value.sum">
                    </range-slider>
                    <div class="labels">
                        <div class="parts">
                            <span v-for="i in parts($calculate.sum_min, $calculate.sum_max, 500)" :key="i"></span>
                        </div>
                        <div class="min-max">
                            <div class="label-min">
                                {{$calculate.sum_min}}
                            </div>
                            <div class="label-min">
                                {{$calculate.sum_max}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- срок займа -->
            <div class="part">
                <div class="block__wrapper">
                    <div class="block">
                        <div class="label">Срок возврата</div>
                        <div class="label-value">{{value.days}} {{$helpers.plural(value.days, ['день', 'дня',
                            'дней'])}}
                        </div>
                    </div>
                    <div class="line"></div>
                    <div class="block">
                        <div class="label">Дата возврата</div>
                        <div class="label-value small">{{dateEnd}}</div>
                    </div>
                </div>

                <div class="slider">
                    <range-slider class="slider"
                                  :min="$calculate.period_min"
                                  :max="$calculate.period_max"
                                  :step="1"
                                  v-model="value.days">
                    </range-slider>
                    <div class="labels">
                        <div class="parts">
                            <span v-for="i in parts($calculate.period_min, $calculate.period_max, 1)" :key="i"></span>
                        </div>
                        <div class="min-max">
                            <div class="label-min">
                                {{$calculate.period_min}}
                            </div>
                            <div class="label-min">
                                {{$calculate.period_max}}
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
</template>

<script>
    import RangeSlider from './RangeSlider'
    // you probably need to import built-in style

    export default {
        components: {
            RangeSlider
        },

        props: {
            value: {
                type: Object
            },

            servicePrice: {
                type: Number,
                required: false,
                default: 0
            }
        },

        computed: {
            /**
             * Дата окончания (текущая дата + кол-во дней)
             */
            dateEnd () {
                return this.$dayjs().subtract(1, 'day').add(this.value.days, 'days').format('DD.MM.YYYY');
            },

            /**
             * Сумма возврата
             */
            returnAmount () {
                let percent = 0;
                for(let i = 0; i < this.value.days; i++) {
                    percent += this.value.sum *  this.$calculate.period_percents[i] / 100
                }
                return (percent + this.value.sum + this.servicePrice).toFixed(2);
            }
        },


        methods: {
            /**
             * Риски под бегунком
             * @param min минимальное значение поля
             * @param max максимальное значение поля
             * @param step шаг
             * @param maxS максимальное число рисков
             * @returns {number}
             */
            parts(min, max, step, maxS = 9) {
                const range = max - min;
                return Math.min(Math.ceil(range / step), maxS);
            }
        }
    };
</script>

<style scoped>

</style>
